import { fiona, injectState, ApiSection } from '../../docs/app'
import { Sample } from '../../docs/components'

const Section = ({ state: { seed } }) =>
  <ApiSection heading={<span><small>fiona.fn.</small>lorem</span>}>
    <p>A seeded utility to return lorem ipsum text, optionally takes `qty` which is approximate number of words and defaults to `15`.</p>

    <Sample input={`
    fiona(${seed}).lorem()

    fiona(${seed}).lorem({ qty: 3 })

    fiona(${seed}).lorem({ qty: 50 })
    `} output={`
    ${fiona(seed).lorem()}

    ${fiona(seed).lorem({ qty: 3 })}

    ${fiona(seed).lorem({ qty: 50 })}
    `} />
  </ApiSection>

export default injectState(Section)
